FUNCTION_BLOCK SF_EDMX
VAR_INPUT
	Activate		: BOOL ;
	S_OutControl	: SAFEBOOL ;
	S_EDM1			: SAFEBOOL ;
	S_EDM2			: SAFEBOOL ;
	MonitoringTime	: TIME;
	S_StartReset	: SAFEBOOL ;
	Reset		  	: BOOL ;
END_VAR

VAR_OUTPUT
	Ready		: BOOL ;
	S_EDM_Out	: SAFEBOOL ;
	Error	    : BOOL ;
	DiagCode	: WORD:=16#0000 ;
END_VAR

VAR
	R_TRIGatReset	    : R_TRIG ;
	R_TRIGatOutControl	: R_TRIG ;
	R_TRIGatEDM1	 	: R_TRIG ;
	R_TRIGatEDM2	 	: R_TRIG ;
	T_1	: TONX ;
END_VAR

(* Rising edge detection *)
R_TRIGatReset(CLK:=Reset);
R_TRIGatOutControl(CLK:=S_OutControl);
R_TRIGatEDM1(CLK:=S_EDM1);
R_TRIGatEDM2(CLK:=S_EDM2);

IF NOT Activate THEN
    DiagCode := 16#0000;
ELSE
    CASE DiagCode OF
    16#0000:
        IF Activate THEN
            DiagCode := 16#8001;
        END_IF;
    16#8000:
        IF T_1.Q AND S_EDM1 AND NOT S_EDM2 THEN
            DiagCode := 16#C070;
        ELSIF T_1.Q AND NOT S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#C080;
        ELSIF T_1.Q AND S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#C090;
        ELSIF NOT S_OutControl THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;        
    16#8001:
        IF Reset AND NOT R_TRIGatReset.Q AND NOT S_StartReset THEN
            DiagCode := 16#C001;
        ELSIF R_TRIGatReset.Q AND R_TRIGatOutControl.Q AND NOT S_StartReset THEN
            DiagCode := 16#C111;
        ELSIF R_TRIGatReset.Q OR S_StartReset THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#8010:
        IF S_OutControl AND NOT S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#C010;
        ELSIF S_OutControl AND S_EDM1 AND NOT S_EDM2 THEN
            DiagCode := 16#C020;
        ELSIF S_OutControl AND NOT S_EDM1 AND NOT S_EDM2 THEN
            DiagCode := 16#C030;
        ELSIF T_1.Q AND NOT S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#C040;
        ELSIF T_1.Q AND S_EDM1 AND NOT S_EDM2 THEN
            DiagCode := 16#C050;
        ELSIF T_1.Q AND NOT S_EDM1 AND NOT S_EDM2 THEN
            DiagCode := 16#C060;
        ELSIF S_OutControl THEN
            DiagCode := 16#8000;
            T_1(IN:=FALSE);
        END_IF;
    16#C001:
        IF NOT Reset THEN
            DiagCode := 16#8001;
        END_IF;
    16#C010, 16#C020, 16#C030:
        IF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND R_TRIGatEDM1.Q AND NOT R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C011;
        ELSIF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND NOT R_TRIGatEDM1.Q AND R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C021;
        ELSIF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND R_TRIGatEDM1.Q AND R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C031;
        ELSIF R_TRIGatReset.Q AND S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#C011:
        IF NOT Reset THEN
            DiagCode := 16#C010;
        END_IF;
    16#C021:
        IF NOT Reset THEN
            DiagCode := 16#C020;
        END_IF;
    16#C031:
        IF NOT Reset THEN
            DiagCode := 16#C030;
        END_IF;
    16#C040, 16#C050, 16#C060:
        IF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND R_TRIGatEDM1.Q AND NOT R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C041;
        ELSIF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND NOT R_TRIGatEDM1.Q AND R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C051;
        ELSIF (Reset AND NOT R_TRIGatReset.Q AND S_EDM1 AND S_EDM2) OR (R_TRIGatReset.Q AND R_TRIGatEDM1.Q AND R_TRIGatEDM2.Q) THEN
            DiagCode := 16#C061;
        ELSIF R_TRIGatReset.Q AND S_EDM1 AND S_EDM2 THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#C041:
        IF NOT Reset THEN
            DiagCode := 16#C040;
        END_IF;
    16#C051:
        IF NOT Reset THEN
            DiagCode := 16#C050;
        END_IF;
    16#C061:
        IF NOT Reset THEN
            DiagCode := 16#C060;
        END_IF;
    16#C070:
        IF Reset AND NOT R_TRIGatReset.Q THEN
            DiagCode := 16#C071;
        ELSIF R_TRIGatReset.Q AND NOT (R_TRIGatEDM1.Q OR R_TRIGatEDM2.Q) THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#C080:
        IF Reset AND NOT R_TRIGatReset.Q THEN
            DiagCode := 16#C081;
        ELSIF R_TRIGatReset.Q AND NOT (R_TRIGatEDM1.Q OR R_TRIGatEDM2.Q) THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#C090:
        IF Reset AND NOT R_TRIGatReset.Q THEN
            DiagCode := 16#C091;
        ELSIF R_TRIGatReset.Q AND NOT (R_TRIGatEDM1.Q OR R_TRIGatEDM2.Q) THEN
            DiagCode := 16#8010;
            T_1(IN:=FALSE);
        END_IF;
    16#C071:
        IF NOT Reset THEN
            DiagCode := 16#C070;
        END_IF;
    16#C081:
        IF NOT Reset THEN
            DiagCode := 16#C080;
        END_IF;
    16#C091:
        IF NOT Reset THEN
            DiagCode := 16#C090;
        END_IF;
    16#C111:
        IF NOT Reset THEN
            DiagCode := 16#8001;
        END_IF;
    END_CASE;
END_IF;

CASE DiagCode OF
    16#0000:
        Ready := FALSE;
        S_EDM_Out := FALSE;
        Error := FALSE;
    16#8001:
        Ready := TRUE;
        S_EDM_Out := FALSE;
        Error := FALSE;
    16#8010:
        Ready := TRUE;
        S_EDM_Out := FALSE;
        Error := FALSE;
        T_1(IN:=TRUE, PT:=MonitoringTime);
    16#8000:
        Ready := TRUE;
        S_EDM_Out := TRUE;
        Error := FALSE;
        T_1(IN:=TRUE, PT:=MonitoringTime);
    16#C001, 16#C010, 16#C011, 16#C020, 16#C021, 16#C030, 16#C031, 16#C040, 16#C041, 16#C050, 16#C051, 16#C060, 16#C061, 16#C070, 16#C071, 16#C080, 16#C081, 16#C090, 16#C091, 16#C111:
        Ready := TRUE;
        S_EDM_Out := FALSE;
        Error := TRUE;
END_CASE;

END_FUNCTION_BLOCK

FUNCTION_BLOCK SF_OutControlX
VAR_INPUT
	Activate		 	: BOOL ;
	S_SafeControl		: SAFEBOOL ;
	ProcessControl		: BOOL ;	
	StaticControl		: BOOL ;
	S_StartReset		: SAFEBOOL ;
	S_AutoReset			: SAFEBOOL ; 
	Reset				: BOOL ;
END_VAR

VAR_OUTPUT
	Ready				: BOOL ;
	S_OutControl		: SAFEBOOL ;
	Error	    		: BOOL ;
	DiagCode			: WORD:=16#0000 ;
END_VAR

VAR
	R_TRIGatReset	 	    : R_TRIG ;
	R_TRIGatProcessControl  : R_TRIG ;
END_VAR

R_TRIGatReset(CLK:=Reset);
R_TRIGatProcessControl(CLK:=ProcessControl);

IF NOT Activate THEN
    DiagCode := 16#0000;
ELSE
    CASE DiagCode OF
        16#0000:
            IF Activate THEN
                DiagCode := 16#8001;
            END_IF;
        16#8000:
            IF NOT S_SafeControl THEN
                DiagCode := 16#8002;
            ELSIF NOT ProcessControl THEN
                DiagCode := 16#8010;       
            END_IF;
        16#8001:
            IF Reset AND NOT R_TRIGatReset.Q AND NOT S_StartReset THEN
                DiagCode := 16#C001;
            ELSIF R_TRIGatReset.Q AND R_TRIGatProcessControl.Q THEN
                DiagCode := 16#C111;
            ELSIF R_TRIGatReset.Q OR S_StartReset THEN
                DiagCode := 16#8010;
            END_IF;
        16#8002:
            IF S_SafeControl THEN
                DiagCode := 16#8003;
            END_IF;
        16#8003:
            IF NOT S_SafeControl THEN
                DiagCode := 16#8002;
            ELSIF Reset AND NOT R_TRIGatReset.Q AND NOT S_AutoReset THEN
                DiagCode := 16#C002;
            ELSIF R_TRIGatReset.Q AND R_TRIGatProcessControl.Q THEN
                DiagCode := 16#C211;
            ELSIF R_TRIGatReset.Q OR S_AutoReset THEN
                DiagCode := 16#8010;
            END_IF;
        16#8010:
            IF NOT S_SafeControl THEN
                DiagCode := 16#8002;
            ELSIF NOT R_TRIGatProcessControl.Q AND ProcessControl AND NOT StaticControl THEN
                DiagCode := 16#C010;
            ELSIF S_SafeControl AND (R_TRIGatProcessControl.Q OR (StaticControl AND ProcessControl)) THEN
                DiagCode := 16#8000;
            END_IF;
        16#C001:
            IF NOT Reset THEN
                DiagCode := 16#8001;
            END_IF;
        16#C002:
            IF NOT Reset THEN
                DiagCode := 16#8003;
            END_IF;
        16#C010:
            IF NOT ProcessControl THEN
                DiagCode := 16#8010;
            END_IF;
        16#C111:
            IF NOT Reset THEN
                DiagCode := 16#8001;
            END_IF;
        16#C211:
            IF NOT Reset THEN
                DiagCode := 16#8003;
            END_IF;
    END_CASE;
END_IF;

CASE DiagCode OF
    16#0000:
        Ready := FALSE;
        S_OutControl := FALSE;
        Error := FALSE;
    16#8000:
        Ready := TRUE;
        S_OutControl := TRUE;
        Error := FALSE;
    16#8001, 16#8002, 16#8003, 16#8010:
        Ready := TRUE;
        S_OutControl := FALSE;
        Error := FALSE;
    16#C001, 16#C002, 16#C010, 16#C111, 16#C211:
        Ready := TRUE;
        S_OutControl := FALSE;
        Error := TRUE;
END_CASE;

END_FUNCTION_BLOCK

FUNCTION_BLOCK SF_TestableSafetySensorX
VAR_INPUT
    Activate : BOOL;
    S_OSSD_In : SAFEBOOL;
    StartTest : BOOL;
    TestTime : TIME := T#10ms;
    NoExternalTest : BOOL;
    S_StartReset : SAFEBOOL;
    S_AutoReset : SAFEBOOL;
    Reset : BOOL;
END_VAR
VAR_OUTPUT
    Ready : SAFEBOOL;
    S_OSSD_Out : SAFEBOOL;
    S_TestOut : SAFEBOOL := TRUE;
    TestPossible : BOOL;
    TestExecuted : BOOL;
    Error : BOOL;
    DiagCode : WORD := 16#0000;
END_VAR
VAR
    R_TRIGatReset : R_TRIG;
    R_TRIGatStartTest : R_TRIG;
    F_TRIGatS_OSSD_In : F_TRIG;
    Timer1: TONX;
    Timer2: TONX;
END_VAR

R_TRIGatReset(CLK:=Reset);
R_TRIGatStartTest(CLK:=StartTest);
F_TRIGatS_OSSD_In(CLK:=S_OSSD_In);

IF NOT Activate THEN
    DiagCode := 16#0000;
ELSE
    CASE DiagCode OF
        16#0000:
            IF Activate THEN
                DiagCode := 16#8001;
            END_IF;
        16#8000:
            IF NOT S_OSSD_In THEN
                DiagCode := 16#8012;
            ELSIF R_TRIGatStartTest.Q THEN
                DiagCode := 16#8020;
                Timer1(IN:=FALSE);
            END_IF;
        16#8001:
            IF TestTime > T#150ms THEN
                DiagCode := 16#C000;
            ELSIF Reset AND NOT R_TRIGatReset.Q AND NOT S_StartReset THEN
                DiagCode := 16#C001;
            ELSIF NOT S_OSSD_In THEN
                DiagCode := 16#8002;
            ELSIF S_OSSD_In AND (R_TRIGatReset.Q OR S_StartReset) THEN
                DiagCode := 16#8010;
            END_IF;
        16#8002:
            IF S_OSSD_In THEN
                DiagCode := 16#8003;
            END_IF;
        16#8003:
            IF Reset AND NOT R_TRIGatReset.Q AND NOT S_AutoReset THEN
                DiagCode := 16#C002;
            ELSIF NOT S_OSSD_In THEN
                DiagCode := 16#8002;
            ELSIF S_OSSD_In AND (R_TRIGatReset.Q OR S_AutoReset) THEN
                DiagCode := 16#8010;
            END_IF;
        16#8004:
            IF F_TRIGatS_OSSD_In.Q THEN
                DiagCode := 16#8005;
            END_IF;
        16#8005:
            IF S_OSSD_In THEN
                DiagCode := 16#8006;
            END_IF;
        16#8006:
            IF Reset AND NOT R_TRIGatReset.Q THEN
                DiagCode := 16#C005;
            ELSIF R_TRIGatReset.Q AND NOT S_OSSD_In THEN
                DiagCode := 16#8002;
            ELSIF R_TRIGatReset.Q AND S_OSSD_In THEN
                DiagCode := 16#8010;
            END_IF;
        16#8010:
            IF NOT S_OSSD_In THEN
                DiagCode := 16#8002;
            ELSIF R_TRIGatStartTest.Q THEN
                DiagCode := 16#8020;
                Timer1(IN:=FALSE);
            END_IF;
        16#8012:
            IF S_OSSD_In THEN
                DiagCode := 16#8013;
            END_IF;
        16#8013:
            IF Reset AND NOT R_TRIGatReset.Q AND NOT S_AutoReset THEN
                DiagCode := 16#C007;
            ELSIF NOT S_OSSD_In THEN
                DiagCode := 16#8012;
            ELSIF S_OSSD_In AND (R_TRIGatReset.Q OR S_AutoReset) THEN
                DiagCode := 16#8000;
            END_IF;
        16#8020:
            IF Timer1.Q THEN
                DiagCode := 16#C020;
            ELSIF NOT S_OSSD_In THEN
                DiagCode := 16#8030;
                Timer2(IN:=FALSE);
            END_IF;
        16#8030:
            IF Timer2.Q THEN
                DiagCode := 16#C030;
            ELSIF S_OSSD_In THEN
                DiagCode := 16#8000;
            END_IF;
        16#C000:
            IF Reset AND NOT R_TRIGatReset.Q THEN
                DiagCode := 16#C006;
            ELSIF R_TRIGatReset.Q AND TestTime <= T#150ms THEN
                DiagCode := 16#8001;
            END_IF;
        16#C001:
            IF NOT Reset THEN
                DiagCode := 16#8001;
            END_IF;
        16#C002:
            IF NOT Reset THEN
                DiagCode := 16#8003;
            END_IF;
        16#C003:
            IF NOT Reset THEN
                DiagCode := 16#C010;
            END_IF;
        16#C004:
            IF NOT Reset THEN
                DiagCode := 16#C020;
            END_IF;
        16#C005:
            IF NOT Reset THEN
                DiagCode := 16#8006;
            END_IF;
        16#C006:
            IF NOT Reset THEN
                DiagCode := 16#C000;
            END_IF;
        16#C007:
            IF NOT Reset THEN
                DiagCode := 16#8013;
            END_IF;
        16#C010:
            IF Reset AND NOT R_TRIGatReset.Q THEN
                DiagCode := 16#C003;
            ELSIF R_TRIGatReset.Q AND NOT NoExternalTest THEN
                DiagCode := 16#8004;
            ELSIF S_OSSD_In AND (R_TRIGatReset.Q AND NoExternalTest) THEN
                DiagCode := 16#8010;
            END_IF;
        16#C020:
            IF Reset AND NOT R_TRIGatReset.Q THEN
                DiagCode := 16#C004;
            ELSIF R_TRIGatReset.Q AND NOT NoExternalTest THEN
                DiagCode := 16#8004;
            ELSIF S_OSSD_In AND (R_TRIGatReset.Q AND NoExternalTest) THEN
                DiagCode := 16#8010;
            END_IF;
    END_CASE;
END_IF;

CASE DiagCode OF
    16#0000:
        Ready := FALSE;
        S_OSSD_Out := FALSE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := FALSE;
        Error := FALSE;
    16#8000:
        Ready := TRUE;
        S_OSSD_Out := TRUE;
        S_TestOut := TRUE;
        TestPossible := TRUE;
        TestExecuted := TRUE;
        Error := FALSE;
    16#8001, 16#8002, 16#8003, 16#8004, 16#8005, 16#8006:
        Ready := TRUE;
        S_OSSD_Out := FALSE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := FALSE;
        Error := FALSE;
    16#8010:
        Ready := TRUE;
        S_OSSD_Out := TRUE;
        S_TestOut := TRUE;
        TestPossible := TRUE;
        TestExecuted := FALSE;
        Error := FALSE;
    16#8012, 16#8013:
        Ready := TRUE;
        S_OSSD_Out := FALSE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := TRUE;
        Error := FALSE;
    16#8020:
        Ready := TRUE;
        S_OSSD_Out := TRUE;
        S_TestOut := FALSE;
        TestPossible := FALSE;
        TestExecuted := FALSE;
        Error := FALSE;
        Timer1(IN:=TRUE, PT:=TestTime);
    16#8030:
        Ready := TRUE;
        S_OSSD_Out := TRUE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := FALSE;
        Error := FALSE;
        Timer2(IN:=TRUE, PT:=TestTime);
    16#C000, 16#C001, 16#C002, 16#C003, 16#C004, 16#C005, 16#C006, 16#C010, 16#C020:
        Ready := TRUE;
        S_OSSD_Out := FALSE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := FALSE;
        Error := TRUE;
    16#C007:
        Ready := TRUE;
        S_OSSD_Out := FALSE;
        S_TestOut := TRUE;
        TestPossible := FALSE;
        TestExecuted := TRUE;
        Error := TRUE;
END_CASE;

END_FUNCTION_BLOCK

PROGRAM Muting
USING PLCopenX;

  VAR_INPUT
	S1_S_EStopIn : SAFEBOOL;
    S2_MutingSwitch11 : BOOL;
    S3_MutingSwitch12 : BOOL;
    S4_MutingSwitch21 : BOOL;
    S5_MutingSwitch22 : BOOL;
    S6_S_GuardSwitch : SAFEBOOL;
    L1_S_MutingLamp : SAFEBOOL;
    S7_S_AOPD_In : SAFEBOOL;
    K1_S_EDM : SAFEBOOL;
    K2_S_EDM : SAFEBOOL;
    S9_Reset : BOOL;
    S0_Reset : BOOL;
    ApplCtrl1 : BOOL;
    StartTest_LC1 : BOOL;
    ApplMutingEnable1 : BOOL;
  END_VAR
  VAR_OUTPUT
    S_EDM_Out_K : SAFEBOOL;
    S_MutingActive_L1 : SAFEBOOL;
    S_TestOut_LightCurtain_S8 : SAFEBOOL;
    
    TestPossible_LC1 : BOOL;
    TestExecuted_LC1 : BOOL;
  END_VAR
  VAR
    S_SafeControl : SAFEBOOL;
    Error_EStop1 : BOOL;
    Diag_EStop1 : WORD;
    Error_Guard1 : BOOL;
    Diag_Guard1 : WORD;
    Error_Muting1 : BOOL;
    Diag_Muting1 : WORD;
    Error_LightCurtain1 : BOOL;
    Diag_LightCurtain1 : WORD;
    Error_OutControl1 : BOOL;
    Diag_OutControl1 : WORD;
    Error_EDM1 : BOOL;
    Diag_EDM1 : WORD;
    SF_EmergencyStop_1 : SF_EmergencyStopX;
    SF_GuardMonitoring_1 : SF_GuardMonitoringX;
    SF_MutingSeq_1 : SF_MutingSeqX;
    SF_LightCurtain_1 : SF_TestableSafetySensorX;
    SF_OutControl_1 : SF_OutControlX;
    SF_EDM_1 : SF_EDMX;
  END_VAR
  
  SF_EmergencyStop_1(Activate:=TRUE, S_EStopIn:=S1_S_EStopIn, S_StartReset:=TRUE, S_AutoReset:= FALSE, Reset:=S9_Reset, Error => Error_EStop1, DiagCode => Diag_EStop1);
  SF_GuardMonitoring_1(Activate:=TRUE, S_GuardSwitch1:=S6_S_GuardSwitch, S_GuardSwitch2:=S6_S_GuardSwitch, DiscrepancyTime:=T#0ms, S_StartReset:=TRUE, S_AutoReset:=FALSE, Reset:=S9_Reset, Error => Error_Guard1, DiagCode => Diag_Guard1);
  SF_LightCurtain_1(Activate:=TRUE, S_OSSD_In:=S7_S_AOPD_In, StartTest:=StartTest_LC1, TestTime:=T#100ms, NoExternalTest:=TRUE, S_StartReset:=TRUE, S_AutoReset:=FALSE, Reset:=S0_Reset, S_TestOut => S_TestOut_LightCurtain_S8, TestPossible => TestPossible_LC1, TestExecuted => TestExecuted_LC1, Error => Error_LightCurtain1, DiagCode => Diag_LightCurtain1);
  SF_MutingSeq_1(Activate:=TRUE, S_AOPD_In:=SF_LightCurtain_1.S_OSSD_Out, MutingSwitch11:=S2_MutingSwitch11, MutingSwitch12:=S3_MutingSwitch12, MutingSwitch21:=S4_MutingSwitch21, MutingSwitch22:=S5_MutingSwitch22, S_MutingLamp:=L1_S_MutingLamp, MaxMutingTime:=T#30s, MutingEnable:=ApplMutingEnable1, S_StartReset:=TRUE, Reset:=S9_Reset, S_MutingActive => S_MutingActive_L1, Error => Error_Muting1, DiagCode => Diag_Muting1);
  
  S_SafeControl := SF_EmergencyStop_1.S_EStopOut AND SF_GuardMonitoring_1.S_GuardMonitoring AND SF_MutingSeq_1.S_AOPD_Out;
  
  SF_OutControl_1(Activate:=TRUE, S_SafeControl:=S_SafeControl, ProcessControl:=ApplCtrl1, StaticControl:=FALSE, S_StartReset:=FALSE, S_AutoReset:=FALSE, Reset:=S0_Reset, Error => Error_OutControl1, DiagCode => Diag_OutControl1);
  SF_EDM_1(Activate:=TRUE, S_OutControl:=SF_OutControl_1.S_OutControl, S_EDM1:=K1_S_EDM, S_EDM2:=K2_S_EDM, MonitoringTime:=T#30ms, Reset:=S0_Reset, S_EDM_Out => S_EDM_Out_K, Error => Error_EDM1, DiagCode => Diag_EDM1);
END_PROGRAM
